MORA_GPS={}
--player table
MORA_GPS.PLAYERS={}
local PLAYERS=MORA_GPS.PLAYERS
--gps locations table
MORA_GPS.GPSLOCATIONS={}
local GPSLOCATIONS=MORA_GPS.GPSLOCATIONS
--map size
local xmax=map'xsize'*32+32
local ymax=map'ysize'*32+32

timer(1,"start")
GPSLOCATIONS={}
function start() --adding positions in table
	for _,e in pairs(entitylist()) do
		if entity(e.x,e.y,"name") == "[GPS]" then
			local x=e.x
			local y=e.y
			local s=entity(e.x,e.y,"trigger")
			table.insert(GPSLOCATIONS,{x,y,string.gsub(s, ",", ";")})
		end
	end
end

addhook("serveraction","MORA_GPS.SERVER_ACTION")
function MORA_GPS.SERVER_ACTION(id,action)
	if action==1 then
	PLAYERS[id].idPage=1
	local tab={"","","","","","","","","Next"}
		for i=1,8 do
			if GPSLOCATIONS[i]~=nil then
				tab[i]=GPSLOCATIONS[i][3].."|[X: "..GPSLOCATIONS[i][1]*32 .."][Y: "..GPSLOCATIONS[i][2]*32 .."]"
			else
				tab[9]=""
				break
			end
		end
		if GPSLOCATIONS[9]==nil then
			tab[9]=""
		end
			menu(id,"GPS - Page "..PLAYERS[id].idPage.."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
	end
	gps_update(id)
	hud_update(id)
end

addhook("menu","MORA_GPS.MENU")
function MORA_GPS.MENU(id,title,sel)
	if title=="GPS - Page 1" then
		if sel>=1 and sel<=8 then
			PLAYERS[id].GPS.Numbers[1]=GPSLOCATIONS[sel][1]*32+16
			PLAYERS[id].GPS.Numbers[2]=GPSLOCATIONS[sel][2]*32+16
			msg2(id,"GPS navigation [X] set at: "..PLAYERS[id].GPS.Numbers[1])
			msg2(id,"GPS navigation [Y] set at: "..PLAYERS[id].GPS.Numbers[2])
			msg2(id,"GPS navigation [Target] is: "..GPSLOCATIONS[sel][3])
			PLAYERS[id].GPS.Target=GPSLOCATIONS[sel][3]
		elseif sel==9 then
			PLAYERS[id].idPage=PLAYERS[id].idPage+1
			local tab={"","","","","","","","Next","Previous"}
			local pos=8+((7*(PLAYERS[id].idPage-2)))
			for i=1,7 do
				if GPSLOCATIONS[i+pos] then
					tab[i]=GPSLOCATIONS[i+pos][3].."|[X: "..GPSLOCATIONS[i+pos][1]*32 .."][Y: "..GPSLOCATIONS[i+pos][2]*32 .."]"
				else
					tab[8]=""
					break
				end
			end
			if GPSLOCATIONS[pos+8]==nil then
				tab[8]=""
			end
			menu(id,"GPS - Page "..PLAYERS[id].idPage.."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		end
	elseif title=="GPS - Page "..PLAYERS[id].idPage.."" then
		local pos=8+((7*(PLAYERS[id].idPage-2)))
		if sel>=1 and sel<=7 then
			if GPSLOCATIONS[sel+pos] then
				PLAYERS[id].GPS.Numbers[1]=GPSLOCATIONS[sel+pos][1]*32+16
				PLAYERS[id].GPS.Numbers[2]=GPSLOCATIONS[sel+pos][2]*32+16
				msg2(id,"GPS navigation [X] set at: "..PLAYERS[id].GPS.Numbers[1])
				msg2(id,"GPS navigation [Y] set at: "..PLAYERS[id].GPS.Numbers[2])
				msg2(id,"GPS navigation [Target] is: "..GPSLOCATIONS[sel+pos][3])
				PLAYERS[id].GPS.Target=GPSLOCATIONS[sel+pos][3]
			end
		elseif sel==8 then
			PLAYERS[id].idPage=PLAYERS[id].idPage+1
			local tab={"","","","","","","","Next","Previous"}
			local pos=8+((7*(PLAYERS[id].idPage-2)))
			for i=1,7 do
				if GPSLOCATIONS[i+pos] then
					tab[i]=GPSLOCATIONS[i+pos][3].."|[X: "..GPSLOCATIONS[i+pos][1]*32 .."][Y: "..GPSLOCATIONS[i+pos][2]*32 .."]"
				else
					tab[8]=""
					break
				end
			end
			if GPSLOCATIONS[pos+8]==nil then
				tab[8]=""
			end
			menu(id,"GPS - Page "..PLAYERS[id].idPage.."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		elseif sel==9 then
			PLAYERS[id].idPage=PLAYERS[id].idPage-1
			local tab={}
			if PLAYERS[id].idPage~=1 then
				tab={"","","","","","","","Next","Previous"}
				local pos=8+((7*(PLAYERS[id].idPage-2)))
				for i=1,7 do
					if GPSLOCATIONS[i+pos] then
						tab[i]=GPSLOCATIONS[i+pos][3].."|[X: "..GPSLOCATIONS[i+pos][1]*32 .."][Y: "..GPSLOCATIONS[i+pos][2]*32 .."]"
					else
						tab[8]=""
						break
					end
				end
			menu(id,"GPS - Page "..PLAYERS[id].idPage.."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			else
				PLAYERS[id].idPage=1
					tab={"","","","","","","","","Next"}
					for i=1,8 do
						if GPSLOCATIONS[i] then
							tab[i]=GPSLOCATIONS[i][3].."|[X: "..GPSLOCATIONS[i][1]*32 .."][Y: "..GPSLOCATIONS[i][2]*32 .."]"
						else
							tab[9]=""
							break
						end
					end
			menu(id,"GPS - Page "..PLAYERS[id].idPage.."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			end
		end
	end
	gps_update(id)
	hud_update(id)
end

addhook("startround","MORA_GPS.STARTROUND")
function MORA_GPS.STARTROUND(roundmode)
	gps_check(id)
end

addhook("endround","MORA_GPS.ENDROUND")
function MORA_GPS.ENDROUND(roundmode)
	gps_check(id)
end

addhook("team","MORA_GPS.TEAM")
function MORA_GPS.TEAM(id, team)
	gps_check(id)
end

addhook("die","MORA_GPS.DIE")
function MORA_GPS.DIE(id)
	PLAYERS[id].GPS.Numbers[1]=0
	PLAYERS[id].GPS.Numbers[2]=0
	gps_update(id)
end

addhook("leave","MORA_GPS.LEAVE")
function MORA_GPS.LEAVE(id,reason)
	if PLAYERS[id] then
		if PLAYERS[id].GPS.Images[1] then
			freeimage(PLAYERS[id].GPS.Images[1])
			freeimage(PLAYERS[id].GPS.Images[2])
			PLAYERS[id].GPS.Images[2]=nil
			PLAYERS[id].GPS.Images[1]=nil
		end
	end
end

addhook("say","MORA_GPS.SAY")
function MORA_GPS.SAY(id,txt)
	if txt:sub(1,2)=="x:" then
		xx = tonumber(txt:sub(3,#txt))
		if xx and xx>0 and xx<=xmax then
			if PLAYERS[id].GPS.Target~="Say" then
				PLAYERS[id].GPS.Numbers[2]=0
			end
			PLAYERS[id].GPS.Numbers[1]=xx
			msg2(id,"GPS navigation [X] set at: "..xx)
			PLAYERS[id].GPS.Target="Say"
			gps_update(id)
			hud_update(id)
			return 1
		else
			errors(id,1)
			gps_update(id)
			hud_update(id)
			return 1
		end
	elseif txt:sub(1,2)=="y:" then
		yy = tonumber(txt:sub(3,#txt))
		if yy and yy>0 and yy<=ymax then
			if PLAYERS[id].GPS.Target~="Say" then
				PLAYERS[id].GPS.Numbers[1]=0
			end
			PLAYERS[id].GPS.Numbers[2]=yy
			msg2(id,"GPS navigation [Y] set at: "..yy)
			PLAYERS[id].GPS.Target="Say"
			gps_update(id)
			hud_update(id)
			return 1
		else
			errors(id,1)
			gps_update(id)
			hud_update(id)
			return 1
		end
	end
end

addhook("move","MORA_GPS.MOVE")
function MORA_GPS.MOVE(id,x,y)
	gps_update(id)
	hud_update(id)
end

function errors(id,errorid)
	if not id then return end
	if not errorid or errorid==0 then return end
	if errorid==1 then
		msg2(id,"[GPS Error]: Something wrong in position set.")
		msg2(id,"[GPS Info]: Map [x]:"..xmax.."[y]:"..ymax..".")
	end
end

function gps_check(id)
	for _,id in pairs(player(0, "table")) do
		if PLAYERS[id]==nil then
			PLAYERS[id]={GPS={Images={nil,nil},Numbers={0,0},Target="Say"},idPage=1}
		end
		PLAYERS[id].GPS.Numbers[1]=0
		PLAYERS[id].GPS.Numbers[2]=0
		if not PLAYERS[id].GPS.Images[1] then
			PLAYERS[id].GPS.Images[1]=image("gfx/mora/GPS/flare.bmp<a>",0,0,3,id)
			imagecolor(PLAYERS[id].GPS.Images[1],255,0,0)
			imagealpha(PLAYERS[id].GPS.Images[1],0)
			tween_rotateconstantly(PLAYERS[id].GPS.Images[1],1)
		else
			freeimage(PLAYERS[id].GPS.Images[1])
			PLAYERS[id].GPS.Images[1]=nil
			PLAYERS[id].GPS.Images[1]=image("gfx/mora/GPS/flare.bmp<a>",0,0,3,id)
			imagecolor(PLAYERS[id].GPS.Images[1],255,0,0)
			imagealpha(PLAYERS[id].GPS.Images[1],0)
			tween_rotateconstantly(PLAYERS[id].GPS.Images[1],1)
			
		end
		if not PLAYERS[id].GPS.Images[2] then
			PLAYERS[id].GPS.Images[2]=image("gfx/mora/GPS/arrow.bmp<a>",0,0,3,id)
			imagecolor(PLAYERS[id].GPS.Images[2],255,0,0)
			imagealpha(PLAYERS[id].GPS.Images[2],0)
		else
			freeimage(PLAYERS[id].GPS.Images[2])
			PLAYERS[id].GPS.Images[2]=nil
			PLAYERS[id].GPS.Images[2]=image("gfx/mora/GPS/arrow.bmp<a>",0,0,3,id)
			imagecolor(PLAYERS[id].GPS.Images[2],255,0,0)
			imagealpha(PLAYERS[id].GPS.Images[2],0)			
		end
		gps_update(id)
		hud_update(id)
	end
end

function gps_update(id)
	if PLAYERS[id]~=nil then
		if PLAYERS[id].GPS.Numbers[1]~=0 and PLAYERS[id].GPS.Numbers[2]~=0 then
			if PLAYERS[id].GPS.Images[1] then
				imagepos(PLAYERS[id].GPS.Images[1],PLAYERS[id].GPS.Numbers[1],PLAYERS[id].GPS.Numbers[2],object(PLAYERS[id].GPS.Images[1],'rot'))
				imagealpha(PLAYERS[id].GPS.Images[1],0.5)
			end
			if PLAYERS[id].GPS.Images[2] then
				local obx,oby=object(PLAYERS[id].GPS.Images[1],"x"),object(PLAYERS[id].GPS.Images[1],"y")
				local px,py=player(id,"x"),player(id,"y")
				local radiusx, radiusy = 320, 240
				local x1, y1, x2, y2 = px-radiusx, py-radiusy, px+radiusx, py+radiusy
				local a = -(math.atan2(obx-px,oby-py)+math.pi/2)%(2*math.pi)
				local nx, ny = px - math.cos(a)*196, py - math.sin(a)*196
				dist=math.sqrt((obx-px)^2+(oby-py)^2)
				if obx >= x1 and obx <= x2 and oby >= y1 and oby <= y2 then
					imagepos(PLAYERS[id].GPS.Images[2],PLAYERS[id].GPS.Numbers[1],PLAYERS[id].GPS.Numbers[2],0)
					imagealpha(PLAYERS[id].GPS.Images[2],1)
					imagecolor(PLAYERS[id].GPS.Images[2],0,255,0)
					imagecolor(PLAYERS[id].GPS.Images[1],0,255,0)
					imagescale(PLAYERS[id].GPS.Images[2],1,1)
				else
					imagepos(PLAYERS[id].GPS.Images[2],nx,ny,-math.deg(math.atan2((obx - px), (oby - py))))
					imagealpha(PLAYERS[id].GPS.Images[2],1)
					imagecolor(PLAYERS[id].GPS.Images[2],255,0,0)
					imagecolor(PLAYERS[id].GPS.Images[1],255,0,0)
					imagescale(PLAYERS[id].GPS.Images[2],1,2)
				end
			end
			if dist<=100 then
				msg2(id,"You reach target position.")
				parse("effect \"flare\" " .. PLAYERS[id].GPS.Numbers[1] .. " " .. PLAYERS[id].GPS.Numbers[2] .. " 32 32 111 255 111")
				PLAYERS[id].GPS.Numbers[1]=0
				PLAYERS[id].GPS.Numbers[2]=0
			end
		else
			if PLAYERS[id].GPS.Images[1] then
				imagepos(PLAYERS[id].GPS.Images[1],0,0,object(PLAYERS[id].GPS.Images[1],'rot'))
				imagealpha(PLAYERS[id].GPS.Images[1],0)
			end
			if PLAYERS[id].GPS.Images[2] then
				imagepos(PLAYERS[id].GPS.Images[2],0,0,0)
				imagealpha(PLAYERS[id].GPS.Images[2],0)
			end
		end
	end
end

function hud_update(id)
	parse('hudtxt2 '..id..' 1 "Your position:" 635 240 2')
	parse('hudtxt2 '..id..' 2 "[X: '..player(id,"x")..']" 635 252 2')
	parse('hudtxt2 '..id..' 3 "[Y: '..player(id,"y")..']" 635 264 2')
	if PLAYERS[id].GPS.Numbers[1]~=0 and PLAYERS[id].GPS.Numbers[2]~=0 then
		parse('hudtxt2 '..id..' 4 "Target position:[X: '..PLAYERS[id].GPS.Numbers[1]..'][Y: '..PLAYERS[id].GPS.Numbers[2]..']" 635 276 2')
		if PLAYERS[id].GPS.Target=="Say" then
			parse('hudtxt2 '..id..' 5 "Target :[Custom position]" 635 288 2')
		else
			parse('hudtxt2 '..id..' 5 "Target :['..string.gsub(PLAYERS[id].GPS.Target, ";", ",")..']" 635 288 2')
		end
	else
		parse('hudtxt2 '..id..' 4 ""')
		parse('hudtxt2 '..id..' 5 ""')
	end	
end
